<?php
// Reassign albums based on specific naming pattern...
// The image names are currently of this format:
// attchID_X_postID_Y_whateverName.(extention), for example:  attachID_36_postID_212_image.jpg
// X (36) is the key used to find the new target album

// Define your new albums and get 'aid' for each (browse `cpg15x_albums`)
// Code updates (use simple text editor or PHP editor if available):
// - $process_album - specify album id to be processed (where pictures are currently assigned...)
// - $album_array   - update below array to specify correct keys and aids for split.
// Save changes and upload this file to cpg root directory
// Login as CPG admin and execute:  http://your_cpg_path/albumsplit.php
// Validate results
// change $update from FALSE to TRUE
// re-upload - and run again for real...
// Optional: set $limit to number of records to process in a run.

$update = FALSE;
$limit = 0;            // by default includes all matching rows - use limit to process x records in an execution... (ie: 1000)
$process_album = '1';  // aid to process   Allows rerunning process if we exceed runtime limits.
// album_array defined as 'upper_limit' => 'aid_to assign' - last entry will also be used for anything greater
$album_array = array('500' => '3',   
                     '1000' => '4',
                     '1500' => '5',
                    );

define('IN_COPPERMINE', true);
require('include/init.inc.php');
if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

$limit = ($limit > 0) ? "LIMIT $limit" : '';
$sql = "SELECT `pid`, `filename` FROM {$CONFIG['TABLE_PICTURES']} WHERE `aid` = '$process_album' ORDER BY `pid` $limit";
if (!$update) echo "SQL: $sql <br />";
$result = cpg_db_query($sql);                                                   // execute sql
$p = $u = 0;                                                                    // initialize counters
while ($picture = cpg_db_fetch_assoc($result)) {                                // get each picture
  $p++;
  // this code is specific to the naming convention of the requestor
  $explode = explode('_', $picture['filename'], 3);                             // extract key for split from filename
  $id = $explode[1];                                                            // key is at array offset 1 - 2nd position
  // end naming convention specific code
  foreach ($album_array AS $key => $aid) {                                      // process through mapping array
    if ($id <= $key) {
      break;                                                                    // have the aid we want... stop processing
    }
  } // end foreach
  // we now have the desired (or last) aid..
  $sqlu = "UPDATE {$CONFIG['TABLE_PICTURES']} SET `aid` = '$aid' WHERE `pid` = '{$picture["pid"]}' LIMIT 1";
  if ($update) {
    $resultu = cpg_db_query($sqlu);                                               // update album for this picture
    $u += cpg_db_affected_rows();                                                 // add up number of updated rows
  } else {
    echo "SQL: $sqlu <br />";
    $u ++;
  }
} // end while
if ($update) {
  echo "Processing complete. $p pictures processed. $u updates made.";          // all done!
} else {
  echo "Processing complete. $p pictures processed. $u SQL statements generated."; // all done!
}
?>